diff -ruNp ejudge-2.3.18/html.c ejudge/html.c
--- ejudge-2.3.18/html.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/html.c	2011-07-11 09:02:04.346277022 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: html.c 6216 2011-04-02 06:32:30Z cher $ */
+/* $Id: html.c 6343 2011-05-22 21:20:22Z cher $ */
 
 /* Copyright (C) 2000-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -1219,6 +1219,7 @@ do_write_kirov_standings(
         const unsigned char *stand_dir,
         int client_flag,
         int only_table_flag,
+        int user_id,
         const unsigned char *header_str,
         unsigned char const *footer_str,
         int raw_flag,
@@ -1509,8 +1510,18 @@ do_write_kirov_standings(
     prob = state->probs[pe->prob_id];
     if (!prob || tind < 0 || pind < 0 || prob->hidden) continue;
 
+    /*
+      if (client_flag != 1 || user_id) {
+        if (run_time < start_time) run_time = start_time;
+        if (current_dur > 0 && run_time - start_time > current_dur) continue;
+        if (global->stand_ignore_after > 0
+            && pe->time >= global->stand_ignore_after)
+          continue;
+      }
+     */
+
     // ignore future runs when not in privileged mode
-    if (!client_flag) {
+    if (!client_flag || user_id > 0) {
       run_time = pe->time;
       if (run_time < start_time) run_time = start_time;
       if (stop_time && run_time > stop_time) run_time = stop_time;
@@ -4308,7 +4319,7 @@ write_standings(
   }
   if (global->score_system == SCORE_KIROV
       || global->score_system == SCORE_OLYMPIAD)
-    do_write_kirov_standings(state, cnts, f, stat_dir, 0, 0, header_str,
+    do_write_kirov_standings(state, cnts, f, stat_dir, 0, 0, 0, header_str,
                              footer_str, 0, accepting_mode, force_fancy_style,
                              0, charset_id, NULL, user_mode);
   else if (global->score_system == SCORE_MOSCOW)
@@ -4657,6 +4668,13 @@ done:
   return 0;
 }
 
+static const unsigned char *
+html_make_title(unsigned char *buf, size_t size, const unsigned char *title)
+{
+  snprintf(buf, size, " title=\"%s\"", title);
+  return buf;
+}
+
 int
 write_xml_team_testing_report(
         const serve_state_t state,
@@ -4665,7 +4683,11 @@ write_xml_team_testing_report(
         int output_only,
         int is_marked,
         const unsigned char *txt,
-        const unsigned char *table_class)
+        const unsigned char *table_class,
+        ej_cookie_t sid,
+        const unsigned char *self_url,
+        const unsigned char *extra_args,
+        const int *action_vec)
 {
   const struct section_global_data *global = state->global;
   testing_report_xml_t r = 0;
@@ -4674,9 +4696,11 @@ write_xml_team_testing_report(
   int need_comment = 0, need_info = 0, is_kirov = 0, i;
   unsigned char cl[128] = { 0 };
   struct html_armor_buffer ab = HTML_ARMOR_INITIALIZER;
-  int visibility = 0, serial = 0, has_full = 0;
+  int visibility = 0, serial = 0, has_full = 0, need_links = 0;
   int status, score, max_score;
   int run_tests, tests_passed;
+  unsigned char hbuf[1024];
+  unsigned char tbuf[1024];
 
   if (table_class && *table_class) {
     snprintf(cl, sizeof(cl), " class=\"%s\"", table_class);
@@ -4791,6 +4815,7 @@ write_xml_team_testing_report(
     if (visibility == TV_FULL) {
       if (t->status == RUN_RUN_TIME_ERR) need_info = 1;
       has_full = 1;
+      if (r->archive_available) need_links = 1;
     }
   }
 
@@ -4808,6 +4833,9 @@ write_xml_team_testing_report(
   if (need_comment) {
     fprintf(f, "<th%s>%s</th>", cl, _("Comment"));
   }
+  if (need_links) {
+    fprintf(f, "<th%s>%s</th>", cl, _("Links"));
+  }
 
   fprintf(f, "</tr>\n");
 
@@ -4892,6 +4920,52 @@ write_xml_team_testing_report(
         xfree(s);
       }
     }
+    if (need_links) {
+      fprintf(f, "<td%s>", cl);
+      if (visibility == TV_FULL) {
+        fprintf(f, "&nbsp;%s[I]</a>",
+                html_hyperref_attr(hbuf, sizeof(hbuf), sid, self_url, extra_args,
+                                   html_make_title(tbuf, sizeof(tbuf), _("Test input data")),
+                                   "action=%d&run_id=%d&test_num=%d",
+                                   action_vec[0], r->run_id, t->num));
+        if (t->output_available) {
+          fprintf(f, "&nbsp;%s[O]</a>",
+                  html_hyperref_attr(hbuf, sizeof(hbuf), sid, self_url, extra_args,
+                                     html_make_title(tbuf, sizeof(tbuf), _("Program output")),
+                                     "action=%d&run_id=%d&test_num=%d",
+                                     action_vec[1], r->run_id, t->num));
+        }
+        if (r->correct_available) {
+          fprintf(f, "&nbsp;%s[A]</a>",
+                  html_hyperref_attr(hbuf, sizeof(hbuf), sid, self_url, extra_args,
+                                     html_make_title(tbuf, sizeof(tbuf), _("Correct answer")),
+                                     "action=%d&run_id=%d&test_num=%d",
+                                     action_vec[2], r->run_id, t->num));
+        }
+        if (t->stderr_available) {
+          fprintf(f, "&nbsp;%s[E]</a>",
+                  html_hyperref_attr(hbuf, sizeof(hbuf), sid, self_url, extra_args,
+                                     html_make_title(tbuf, sizeof(tbuf), _("Program stderr output")),
+                                     "action=%d&run_id=%d&test_num=%d",
+                                     action_vec[3], r->run_id, t->num));
+        }
+        if (t->checker_output_available) {
+          fprintf(f, "&nbsp;%s[C]</a>",
+                  html_hyperref_attr(hbuf, sizeof(hbuf), sid, self_url, extra_args,
+                                     html_make_title(tbuf, sizeof(tbuf), _("Checker output")),
+                                     "action=%d&run_id=%d&test_num=%d",
+                                     action_vec[4], r->run_id, t->num));
+        }
+        if (r->info_available) {
+          fprintf(f, "&nbsp;%s[F]</a>",
+                  html_hyperref_attr(hbuf, sizeof(hbuf), sid, self_url, extra_args,
+                                     html_make_title(tbuf, sizeof(tbuf), _("Test information")),
+                                     "action=%d&run_id=%d&test_num=%d",
+                                     action_vec[5], r->run_id, t->num));
+        }
+      }
+      fprintf(f, "</td>");
+    }
     fprintf(f, "</tr>\n");
   }
   fprintf(f, "</table>\n");
diff -ruNp ejudge-2.3.18/html.h ejudge/html.h
--- ejudge-2.3.18/html.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/html.h	2011-07-11 09:02:04.353276893 +0400
@@ -1,5 +1,5 @@
 /* -*- c -*- */
-/* $Id: html.h 6111 2011-03-14 20:55:17Z cher $ */
+/* $Id: html.h 6343 2011-05-22 21:20:22Z cher $ */
 #ifndef __HTML_H__
 #define __HTML_H__
 
@@ -84,7 +84,9 @@ do_write_kirov_standings(
         const struct contest_desc *cnts,
         FILE *f,
         const unsigned char *stand_dir,
-        int client_flag, int only_table_flag,
+        int client_flag,
+        int only_table_flag,
+        int user_id,
         const unsigned char *header_str,
         unsigned char const *footer_str,
         int raw_flag,
@@ -188,7 +190,11 @@ write_xml_team_testing_report(
         int output_only,
         int is_marked,
         const unsigned char *txt,
-        const unsigned char *table_class);
+        const unsigned char *table_class,
+        ej_cookie_t sid,
+        const unsigned char *self_url,
+        const unsigned char *extra_args,
+        const int *action_vec);
 
 int
 write_xml_team_tests_report(
diff -ruNp ejudge-2.3.18/html_hyperref.c ejudge/html_hyperref.c
--- ejudge-2.3.18/html_hyperref.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/html_hyperref.c	2011-07-11 09:02:04.181280054 +0400
@@ -1,7 +1,7 @@
 /* -*- mode: c -*- */
-/* $Id: html_hyperref.c 5675 2010-01-19 09:52:11Z cher $ */
+/* $Id: html_hyperref.c 6343 2011-05-22 21:20:22Z cher $ */
 
-/* Copyright (C) 2005-2006 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2005-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -51,9 +51,44 @@ html_hyperref(unsigned char *buf, size_t
   return buf;
 }
 
+unsigned char *
+html_hyperref_attr(
+        unsigned char *buf,
+        size_t size,
+        ej_cookie_t session_id,
+        const unsigned char *self_url,
+        const unsigned char *extra_args,
+        const unsigned char *attrs,
+        const char *format,
+        ...)
+{
+  unsigned char b[1024] = { 0 };
+  va_list args;
+
+  if (!attrs) attrs = "";
+  if (format && *format) {
+    va_start(args, format);
+    vsnprintf(b, sizeof(b), format, args);
+    va_end(args);
+  }
+
+  if (extra_args && *extra_args && *b) {
+    snprintf(buf, size, "<a%s href=\"%s?SID=%016llx&%s&%s\">",
+             attrs, self_url, session_id, extra_args, b);
+  } else if (extra_args && *extra_args) {
+    snprintf(buf, size, "<a%s href=\"%s?SID=%016llx&%s\">",
+             attrs, self_url, session_id, extra_args);
+  } else if (*b) {
+    snprintf(buf, size, "<a%s href=\"%s?SID=%016llx&%s\">", attrs, self_url, session_id, b);
+  } else {
+    snprintf(buf, size, "<a%s href=\"%s?SID=%016llx\">", attrs, self_url, session_id);
+  }
+
+  return buf;
+}
+
 /*
  * Local variables:
  *  compile-command: "make"
- *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "va_list" "fd_set" "DIR")
  * End:
  */
diff -ruNp ejudge-2.3.18/html_input_text.c ejudge/html_input_text.c
--- ejudge-2.3.18/html_input_text.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/html_input_text.c	2011-07-11 09:02:04.666271137 +0400
@@ -1,7 +1,7 @@
 /* -*- mode: c -*- */
-/* $Id: html_input_text.c 5675 2010-01-19 09:52:11Z cher $ */
+/* $Id: html_input_text.c 6323 2011-05-08 20:39:15Z cher $ */
 
-/* Copyright (C) 2006-2007 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -48,6 +48,40 @@ html_input_text(unsigned char *buf, size
   return buf;
 }
 
+unsigned char *
+html_input_text_js(
+        unsigned char *buf,
+        size_t size,
+        const unsigned char *var_name,
+        int text_size,
+        const unsigned char *onchange,
+        const char *format,
+        ...)
+{
+  va_list args;
+  unsigned char bformat[1024] = { 0 };
+  unsigned char bsize[128];
+  unsigned char bname[128];
+  unsigned char bonchange[128];
+
+  if (format && *format) {
+    va_start(args, format);
+    vsnprintf(bformat, sizeof(bformat), format, args);
+    va_end(args);
+  }
+
+  bsize[0] = 0;
+  if (text_size > 0) snprintf(bsize, sizeof(bsize), " size=\"%d\"", text_size);
+  bname[0] = 0;
+  if (var_name) snprintf(bname, sizeof(bname), " name=\"%s\"", var_name);
+  bonchange[0] = 0;
+  if (onchange) snprintf(bonchange, sizeof(bonchange), " onchange=\"%s\"", onchange);
+
+  snprintf(buf, size, "<input type=\"text\"%s%s%s value=\"%s\"/>",
+           bsize, bname, bonchange, bformat);
+  return buf;
+}
+
 /*
  * Local variables:
  *  compile-command: "make"
diff -ruNp ejudge-2.3.18/job-server.c ejudge/job-server.c
--- ejudge-2.3.18/job-server.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/job-server.c	2011-07-11 09:02:04.406275917 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: job-server.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: job-server.c 6347 2011-05-23 19:06:12Z cher $ */
 
 /* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -25,6 +25,7 @@
 #include "fileutl.h"
 #include "startstop.h"
 #include "compat.h"
+#include "misctext.h"
 
 #include "reuse_xalloc.h"
 #include "reuse_logger.h"
@@ -76,7 +77,7 @@ prepare_config_vars(void)
         return -1;
     }
   } else {
-    if (make_path_in_var_dir(job_server_log_path, "job_server.log") < 0)
+    if (make_path_in_var_dir(job_server_log_path, "ej-jobs.log") < 0)
       return -1;
   }
 
@@ -450,6 +451,23 @@ handle_mail_packet(int uid, int argc, ch
   if (argv[1][0]) charset = argv[1];
   if (!charset) charset = EJUDGE_CHARSET;
 
+  if (!argv[3] || !*argv[3]) {
+    err("mail: source email address is empty");
+    goto cleanup;
+  }
+  if (!is_valid_email_address(argv[3])) {
+    err("mail: source email address is invalid");
+    goto cleanup;
+  }
+  if (!argv[4] || !*argv[4]) {
+    err("mail: destination email address is empty");
+    goto cleanup;
+  }
+  if (!is_valid_email_address(argv[4])) {
+    err("mail: destination email address is invalid");
+    goto cleanup;
+  }
+
   cur_time = time(0);
   ptm = localtime(&cur_time);
   strftime(date_buf, sizeof(date_buf), "%a, %d %b %Y %H:%M:%S %z", ptm);
diff -ruNp ejudge-2.3.18/lang_config_vis.c ejudge/lang_config_vis.c
--- ejudge-2.3.18/lang_config_vis.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/lang_config_vis.c	2011-07-11 09:02:04.381276378 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: lang_config_vis.c 6146 2011-03-26 10:47:14Z cher $ */
+/* $Id: lang_config_vis.c 6387 2011-06-30 05:23:15Z cher $ */
 
 /* Copyright (C) 2008-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -672,7 +672,8 @@ lang_configure_screen(
         const unsigned char *working_dir,
         unsigned char **keys,
         unsigned char **values,
-        const unsigned char *header)
+        const unsigned char *header,
+        int batch_mode)
 {
   WINDOW *in_win = 0, *out_win = 0;
   PANEL *in_pan = 0, *out_pan = 0;
@@ -705,9 +706,12 @@ lang_configure_screen(
 
   reconfigure_all_languages(script_dir, script_in_dirs, config_dir,
                             working_dir, keys, values, 0, in_win);
-  ncurses_print_help("Press any key");
-  doupdate();
-  c = getch();
+
+  if (!batch_mode) {
+    ncurses_print_help("Press any key");
+    doupdate();
+    c = getch();
+  }
 
   if (in_pan) del_panel(in_pan);
   if (out_pan) del_panel(out_pan);
@@ -762,7 +766,7 @@ lang_config_menu(
   unsigned char lang_id_buf[32];
 
   lang_configure_screen(script_dir, script_in_dirs, 0,
-                        working_dir, 0, 0, header);
+                        working_dir, 0, 0, header, 0);
   assign_lang_ids();
 
   for (pcfg = lang_first; pcfg; pcfg = pcfg->next) {
@@ -1007,6 +1011,9 @@ lang_config_generate_compile_cfg(
     if ((s = shellconfig_get(p->cfg, "secure"))) {
       fprintf(f, "disable_security\n");
     }
+    if ((s = shellconfig_get(p->cfg, "binary"))) {
+      fprintf(f, "binary\n");
+    }
     if (!(s = shellconfig_get(p->cfg, "cmd"))) s = p->lang;
     fprintf(f, "cmd = \"%s\"\n", s);
     if ((s = shellconfig_get(p->cfg, "arch"))) {
diff -ruNp ejudge-2.3.18/lang_config_vis.h ejudge/lang_config_vis.h
--- ejudge-2.3.18/lang_config_vis.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/lang_config_vis.h	2011-07-11 09:02:04.383276342 +0400
@@ -1,9 +1,9 @@
 /* -*- c -*- */
-/* $Id: lang_config_vis.h 5675 2010-01-19 09:52:11Z cher $ */
+/* $Id: lang_config_vis.h 6325 2011-05-09 06:47:13Z cher $ */
 #ifndef __LANG_CONFIG_VIS_H__
 #define __LANG_CONFIG_VIS_H__
 
-/* Copyright (C) 2008 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2008-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -47,7 +47,8 @@ lang_configure_screen(
         const unsigned char *working_dir,
         unsigned char **keys,
         unsigned char **values,
-        const unsigned char *header);
+        const unsigned char *header,
+        int batch_mode);
 void
 lang_configure_batch(
         const unsigned char *script_dir,
diff -ruNp ejudge-2.3.18/Makefile.unix.in ejudge/Makefile.unix.in
--- ejudge-2.3.18/Makefile.unix.in	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/Makefile.unix.in	2011-07-11 09:02:04.194279817 +0400
@@ -1,5 +1,5 @@
 # -*- Makefile -*-
-# $Id: Makefile.unix.in 6185 2011-03-27 15:16:29Z cher $
+# $Id: Makefile.unix.in 6328 2011-05-10 04:25:31Z cher $
 # @configure_input@
 
 # Copyright (C) 2000-2011 Alexander Chernov <cher@ejudge.ru> */
@@ -174,11 +174,12 @@ NSM_OBJECTS = $(NSM_CFILES:.c=.o) libcom
 NSC_CFILES=new-server-control.c version.c
 NSC_OBJECTS=$(NSC_CFILES:.c=.o) libcommon.a libnew_server_clnt.a libplatform.a libcommon.a
 
+INSTALLSCRIPT = ejudge-install.sh
 BINTARGETS = ejudge-jobs-cmd ejudge-edit-users ejudge-setup ejudge-configure-compilers ejudge-control ejudge-execute ejudge-contests-cmd
 SERVERBINTARGETS = ej-compile ej-compile-control ej-run ej-nwrun ej-ncheck ej-batch ej-serve ej-users ej-users-control ej-jobs ej-jobs-control ej-super-server ej-super-server-control ej-contests ej-contests-control uudecode ej-convert-clars ej-convert-runs ej-fix-db
 CGITARGETS = users${CGI_PROG_SUFFIX} serve-control${CGI_PROG_SUFFIX} new-client${CGI_PROG_SUFFIX}
 TARGETS = ${SERVERBINTARGETS} ${BINTARGETS} ${CGITARGETS}
-STYLEFILES = style/logo.gif style/priv.css style/unpriv.css style/priv.js style/unpriv.js style/filter_expr.html
+STYLEFILES = style/logo.gif style/priv.css style/unpriv.css style/priv.js style/unpriv.js style/filter_expr.html style/sprintf.js
 
 all: local_all subdirs_all mo
 local_all: $(TARGETS) ejudge-config
@@ -204,6 +205,8 @@ install_ej_users: ej-users
 	install -m 0755 ej-users "${DESTDIR}${serverbindir}"
 install_ej_contests: ej-contests
 	install -m 0755 ej-contests "${DESTDIR}${serverbindir}"
+install_ej_super_server: ej-super-server
+	install -m 0755 ej-super-server "${DESTDIR}${serverbindir}"
 
 local_install: ${TARGETS} ejudge-config po mo
 	install -d "${DESTDIR}${bindir}"
@@ -230,6 +233,8 @@ local_install: ${TARGETS} ejudge-config 
 	install -m 0755 style/ejudge-upgrade-web "${DESTDIR}${bindir}"
 	mkdir -p "${DESTDIR}${includedir}/ejudge"
 	for i in problem_plugin_impl.h problem_plugin.h ejudge_plugin.h ej_types.h iterators.h contest_plugin.h; do install -m 644 $$i "${DESTDIR}${includedir}/ejudge"; done
+	if [ ! -f "${INSTALLSCRIPT}" ]; then ./ejudge-setup -b; fi
+	if [ -f "${INSTALLSCRIPT}" ]; then install -m 0755 "${INSTALLSCRIPT}" "${DESTDIR}${bindir}"; fi
 
 install: local_install
 	$(MAKE) -C scripts DESTDIR="${DESTDIR}" install
@@ -280,7 +285,7 @@ ejudge-jobs-cmd: ${JP_OBJECTS}
 	${LD} ${LDFLAGS} $^ libcommon.a -o $@ ${LDLIBS} ${EXPAT_LIB}
 
 ej-super-server: ${SS_OBJECTS}
-	${LD} ${LDFLAGS} $^ libcommon.a -o $@ ${LDLIBS} ${EXPAT_LIB}
+	${LD} ${LDFLAGS} -rdynamic $^ libcommon.a -o $@ ${LDLIBS} ${EXPAT_LIB} -ldl
 
 ej-super-server-control: ${SSC_OBJECTS}
 	${LD} ${LDFLAGS} $^ libcommon.a -o $@ ${LDLIBS} ${EXPAT_LIB}
@@ -336,6 +341,9 @@ make-js-actions : make-js-actions.o
 struct-sizes : struct-sizes.o
 	$(LD) $(LDFLAGS) $^ -o $@ $(LDLIBS) ${EXPAT_LIB}
 
+ejudge-install.sh : ejudge-setup
+	./ejudge-setup -b
+
 local_clean:
 	-rm -f *.o *~ *.a $(TARGETS) revinfo version.c $(ARCH)/*.o ejudge.po mkChangeLog2 userlist_clnt/*.o xml_utils/*.o super_clnt/*.o cdeps deps.make filter_expr.[ch] filter_scan.c users users${CGI_PROG_SUFFIX} ejudge-config serve-control serve-control${CGI_PROG_SUFFIX} prjutils/*.o make-js-actions new_server_clnt/*.o mktable struct-sizes
 	-rm -rf locale
@@ -436,7 +444,7 @@ endif
 locale/ru_RU.${CHARSET}/LC_MESSAGES/ejudge.mo : ejudge.ru_RU.${CHARSET}.po ru_all
 	${MSGFMT} -o $@ -c $<
 
-libcommon.a : $(COMMON_CFILES:.c=.o) filter_scan.o filter_expr.o contests_meta.o super-serve_meta.o prepare_meta.o
+libcommon.a : $(COMMON_CFILES:.c=.o) filter_scan.o filter_expr.o contests_meta.o super-serve_meta.o prepare_meta.o super_html_6_meta.o
 	ar rcv $@ $^
 
 libplatform.a : $(PLATFORM_CFILES:.c=.o)
@@ -463,16 +471,14 @@ filter_expr.c filter_expr.h : filter_exp
 filter_scan.c : filter_scan.lex
 	flex -p -s -L -8 -B -o$@ -Pfilter_expr_ $<
 
-contests_meta.c contests_meta.h : contests.h
-	$(META_CC) contests.h -o contests.out --force-h --meta --meta-struct contest_desc --meta-enum-prefix CNTS --meta-func-prefix contest_desc --meta-timestamp
-
-super-serve_meta.c super-serve_meta.h : super-serve.h
-	$(META_CC) super-serve.h -o super-serve.out --force-h --meta --meta-struct sid_state --meta-enum-prefix SSSS --meta-func-prefix ss_sid_state --meta-timestamp
-
-prepare_meta.c prepare_meta.h : prepare.h
-	$(META_CC) prepare.h -o prepare.out --force-h --meta --meta-struct section_global_data --meta-struct section_problem_data --meta-struct section_language_data --meta-struct section_tester_data --meta-enum-prefix CNTSGLOB --meta-enum-prefix CNTSPROB --meta-enum-prefix CNTSLANG --meta-enum-prefix CNTSTESTER --meta-func-prefix cntsglob --meta-func-prefix cntsprob --meta-func-prefix cntslang --meta-func-prefix cntstester --meta-timestamp
+include meta.make
 
 style/actions.js : make-js-actions
 	./make-js-actions > style/actions.js
 
+contest-1/contest-1.c : contest-1/contest-1.tar.gz
+	contest-1/make-c.sh contest-1.tar.gz contest-1/contest-1.tar.gz contest-1/contest-1.c
+contest-1/contest-1.tar.gz :
+	tar cvz --exclude-vcs -C contest-1 -f contest-1/contest-1.tar.gz problems
+
 include deps.make
diff -ruNp ejudge-2.3.18/meta_generic.c ejudge/meta_generic.c
--- ejudge-2.3.18/meta_generic.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/meta_generic.c	2011-07-11 09:02:04.662271212 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: meta_generic.c 6146 2011-03-26 10:47:14Z cher $ */
+/* $Id: meta_generic.c 6286 2011-04-30 20:34:42Z cher $ */
 
 /* Copyright (C) 2008-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -124,3 +124,32 @@ meta_lookup_string(const struct meta_aut
   }
   return -atm->st[cur_st][0];
 }
+
+void
+meta_destroy_fields(const struct meta_methods *mth, void *ptr)
+{
+  int field_id, ft;
+  void *fp;
+
+  for (field_id = 1; field_id < mth->last_tag; ++field_id) {
+    ft = mth->get_type(field_id);
+    fp = mth->get_ptr_nc(ptr, field_id);
+    if (!fp) continue;
+    switch (ft) {
+    case '0':                   /* ej_int_opt_0_t */
+    case '3':                   /* ej_checkbox_t */
+    case '4':                   /* ej_int_opt_1_t */
+      break;
+    case '1':                   /* ej_textbox_t */
+    case '2':                   /* ej_textbox_opt_t */
+      {
+        unsigned char **pp = (unsigned char **) fp;
+        xfree(*pp);
+      }
+      break;
+    default:
+      abort();
+    }
+  }
+  memset(ptr, 0, mth->size);
+}
diff -ruNp ejudge-2.3.18/meta_generic.h ejudge/meta_generic.h
--- ejudge-2.3.18/meta_generic.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/meta_generic.h	2011-07-11 09:02:04.665271155 +0400
@@ -1,10 +1,10 @@
 /* -*- c -*- */
-/* $Id: meta_generic.h 5363 2008-11-23 17:08:07Z cher $ */
+/* $Id: meta_generic.h 6286 2011-04-30 20:34:42Z cher $ */
 
 #ifndef __META_GENERIC_H__
 #define __META_GENERIC_H__
 
-/* Copyright (C) 2008 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2008-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -50,6 +50,8 @@ meta_lookup_string(const struct meta_aut
 
 struct meta_methods
 {
+  int last_tag;
+  size_t size;
   int (*get_type)(int tag);
   size_t (*get_size)(int tag);
   const char *(*get_name)(int tag);
@@ -58,4 +60,7 @@ struct meta_methods
   int (*lookup_field)(const char *name);
 };
 
+void
+meta_destroy_fields(const struct meta_methods *mth, void *ptr);
+
 #endif /* __META_GENERIC_H__ */
diff -ruNp ejudge-2.3.18/meta.make ejudge/meta.make
--- ejudge-2.3.18/meta.make	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/meta.make	2011-07-11 09:02:04.809268510 +0400
@@ -0,0 +1,27 @@
+# -*- Makefile -*-
+# $Id: meta.make 6335 2011-05-18 05:22:54Z cher $
+
+# Copyright (C) 2011 Alexander Chernov <cher@ejudge.ru> */
+
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2 of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+
+contests_meta.c contests_meta.h : contests.h
+	$(META_CC) contests.h -o contests.out --force-h --meta --meta-struct contest_desc --meta-enum-prefix CNTS --meta-func-prefix contest_desc --meta-timestamp
+
+super-serve_meta.c super-serve_meta.h : super-serve.h
+	$(META_CC) super-serve.h -o super-serve.out --force-h --meta --meta-struct sid_state --meta-enum-prefix SSSS --meta-func-prefix ss_sid_state --meta-timestamp
+
+prepare_meta.c prepare_meta.h : prepare.h
+	$(META_CC) prepare.h -o prepare.out --force-h --meta --meta-struct section_global_data --meta-struct section_problem_data --meta-struct section_language_data --meta-struct section_tester_data --meta-enum-prefix CNTSGLOB --meta-enum-prefix CNTSPROB --meta-enum-prefix CNTSLANG --meta-enum-prefix CNTSTESTER --meta-func-prefix cntsglob --meta-func-prefix cntsprob --meta-func-prefix cntslang --meta-func-prefix cntstester --meta-timestamp
+
+super_html_6_meta.c super_html_6_meta.h : super_html_6.h
+	$(META_CC) super_html_6.h -o super_html_6.out --force-h --meta --meta-struct ss_op_param_USER_CREATE_ONE_ACTION --meta-struct ss_op_param_USER_CREATE_MANY_ACTION --meta-struct ss_op_param_USER_CREATE_FROM_CSV_ACTION --meta-struct ss_op_param_USER_CREATE_REG_ACTION --meta-struct ss_op_param_USER_EDIT_REG_ACTION --meta-timestamp
+
diff -ruNp ejudge-2.3.18/mischtml.h ejudge/mischtml.h
--- ejudge-2.3.18/mischtml.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/mischtml.h	2011-07-11 09:02:04.430275477 +0400
@@ -1,9 +1,9 @@
 /* -*- c -*- */
-/* $Id: mischtml.h 5675 2010-01-19 09:52:11Z cher $ */
+/* $Id: mischtml.h 6343 2011-05-22 21:20:22Z cher $ */
 #ifndef __MISCHTML_H__
 #define __MISCHTML_H__
 
-/* Copyright (C) 2005-2009 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2005-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -29,6 +29,15 @@ unsigned char *html_hyperref(unsigned ch
                              const unsigned char *extra_args,
                              const char *format, ...)
   __attribute__((format(printf, 6, 7)));
+unsigned char *html_hyperref_attr(
+        unsigned char *buf,
+        size_t size,
+        ej_cookie_t session_id,
+        const unsigned char *self_url,
+        const unsigned char *extra_args,
+        const unsigned char *attrs,
+        const char *format, ...)
+  __attribute__((format(printf, 7, 8)));
 
 void html_start_form(FILE *f, int mode,
                      unsigned char const *self_url,
@@ -50,6 +59,15 @@ unsigned char *html_input_text(unsigned 
                                int text_size, const char *format,
                                ...)
   __attribute__((format(printf, 5, 6)));
+unsigned char *html_input_text_js(
+        unsigned char *buf,
+        size_t size,
+        const unsigned char *var_name,
+        int text_size,
+        const unsigned char *onchange,
+        const char *format,
+        ...)
+  __attribute__((format(printf, 6, 7)));
 unsigned char *html_input_password(unsigned char *buf, size_t size,
                                    const unsigned char *var_name,
                                    int text_size, const char *format,
